<template>
  <b-modal
    id="add-user-modal"
    v-model="openModal"
    size="md"
    title="Supprimer un groupe d'organisations"
  >
    <div>
      <b-overlay
        id="overlay-background"
        :show="loading"
        :variant="'white'"
        :opacity="0.7"
        :blur="'2px'"
        rounded="sm"
      >
        <p v-if="usergroup">Le groupe d'organisations <strong>{{ usergroup['Sphere'] }}</strong> sera définitivement supprimé.</p>
        <p v-if="usergroup">Il comprend <strong>{{ spheres.find(el => el.id === usergroup.id).children.length }}</strong> organisations.</p>
        <p>Etes-vous sûr de vouloir continuer?</p>
      </b-overlay>
    </div>
    <template #modal-footer>
      <div class="w-100">
        <b-button
          variant="outline-secondary"
          class="float-left"
          @click="hide"
        >
          Annuler
        </b-button>
        <b-button
          variant="primary"
          class="float-right"
          @click="deleteSphere"
        >
          Confirmer
        </b-button>
      </div>
    </template>
  </b-modal>
</template>

<script>
import { mapState, mapActions } from 'vuex';

export default {
  name: 'DeleteSphere',

  props: {
    open: {
      type: Boolean,
      default: false
    },
    usergroup: {
      type: Object,
      default: () => { return {} }
    }
  },

  data() {
    return {
      openModal: false,
      loading: false
    }
  },

  computed: {
    ...mapState('usergroups', ['spheres'])
  },

  watch: {
    open: function(newValue) {
      this.resetModal();
      this.openModal = newValue;
    }
  },

  methods: {
    ...mapActions('usergroups', [
      'DELETE_USERGROUP'
    ]),

    resetModal() {
      this.openModal = false;
      this.loading = false;
    },
    deleteSphere() {
      this.loading = true;
      this.DELETE_USERGROUP(this.usergroup.id)
      .then(() => {
        this.loading = false;
        this.$emit('update');
        this.$emit('hide');
      }).catch(() => {
        this.loading = false;
        this.$emit('hide');
      });
    },
    hide() {
      this.$emit('hide');
    }
  }
}
</script>

<style lang="less" scoped>

h2 {
  color: @blue;
  margin-top: 0.8em;
  margin-left: 0.5em;
}

h4 {
  color: @blue;
  margin-top: 0.8em;
}

</style>
